﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections;

namespace CustomOrderInGroup
{
    /// <summary>
    /// Interaction logic for Test.xaml
    /// </summary>
    public partial class Test : Window
    {
        public Test()
        {
            InitializeComponent();

            AbbreviationSortComparer grpCompare = new AbbreviationSortComparer();

            foreach (Field fld in xamDataGrid1.FieldLayouts[0].Fields)
            {
                fld.Settings.GroupByComparer = (IComparer)grpCompare;
            }

            List<DataCls> gdSource = new List<DataCls>();

            gdSource.Add(new DataCls { ID = 1, Abbreviation = "", IDName = "N1" });
            gdSource.Add(new DataCls { ID = 1, Abbreviation = "", IDName = "N2" });
            
            for (int cnt1 = 0; cnt1 <= 50; cnt1++)
            {
                for (int cnt2 = 1; cnt2 <= 2; cnt2++)
                {
                    gdSource.Add(new DataCls { ID = cnt1, Abbreviation = cnt1.ToString(), IDName = "N" + cnt2.ToString() });
                }
            }

            //for (int cnt1 = 0; cnt1 <= 10; cnt1++)
            //{
            //    gdSource.Add(new DataCls { ID = 1.1234 * cnt1, Abbreviation = "z" + cnt1.ToString(), IDName = "N" + (2 * cnt1).ToString() });
            //}
            xamDataGrid1.DataSource = gdSource;
        }

        private void ContentControl_Loaded(object sender, RoutedEventArgs e)
        {
            if ((sender as ContentControl).Content.ToString().Contains("item"))
            {
                (sender as ContentControl).Content = string.Empty;
            }
        }
    }
    public class DataCls
    {
        public double ID { get; set; }
        public string Abbreviation { get; set; }
        public string IDName { get; set; }
    }
    public class SummaryTextFormatNumeric : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            SummaryResult sr = (value as SummaryResult);
            string strformat = "N1"; // Data.DataSource.dicColFrmts[sr.SourceField.Name];
            if (sr.Value != null)
            {
                return Double.Parse(sr.Value.ToString()).ToString(strformat);
            }
            return Double.Parse("0").ToString(strformat);
            return sr.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
    public class AbbreviationSortComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            var gbX = x as GroupByRecord;
            var gbY = y as GroupByRecord;

            if (gbX == gbY)
                return 0;
            else if (gbX == null)
                return -1;
            else if (gbY == null)
                return 1;

            /*** Begin Remove item text****/

            if (gbX.Value.ToString() == "")
            {
                gbX.Description = " ";
            }
            else
            {
                gbX.Description = Convert.ToString(gbX.Value);
            }

            if (gbY.Value.ToString() == "")
            {
                gbY.Description = " ";
            }
            else
            {
                gbY.Description = Convert.ToString(gbY.Value);
            }

            var summariesX = gbX.ChildRecords.SummaryResults;
            var summariesY = gbY.ChildRecords.SummaryResults;

            // sorting on summary column (in case group by selected and trying to sort on summary column)
            if (summariesX.Count != 0)
            {
                //ex: ID column summary
                var result = Comparer.Default.Compare(summariesX[0].Value, summariesY[0].Value);

                if (result != 0)
                    return result;

            }

            if (gbX.Value == DBNull.Value && gbY.Value == DBNull.Value)
                return 0;
            else if (gbX.Value == DBNull.Value)
                return -1;
            else if (gbY.Value == DBNull.Value)
                return 1;
            else
                return Comparer.Default.Compare(gbX.Value, gbY.Value);
        }
    }

}
